diff --git a/sysdeps/ieee754/ldbl-opt/w_acos_compat.c b/sysdeps/ieee754/ldbl-opt/w_acos_compat.c
index 2934041..1e6d1b3 100644
--- a/sysdeps/ieee754/ldbl-opt/w_acos_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_acos_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_acos.c>
+#include <math/w_acos_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __acos, acosl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_acosh_compat.c b/sysdeps/ieee754/ldbl-opt/w_acosh_compat.c
index 7f7fa14..40da339 100644
--- a/sysdeps/ieee754/ldbl-opt/w_acosh_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_acosh_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_acosh.c>
+#include <math/w_acosh_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __acosh, acoshl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_acoshl_compat.c b/sysdeps/ieee754/ldbl-opt/w_acoshl_compat.c
index 6243c2a..df4338d 100644
--- a/sysdeps/ieee754/ldbl-opt/w_acoshl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_acoshl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_acoshl.c>
+#include <math/w_acoshl_compat.c>
 long_double_symbol (libm, __acoshl, acoshl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_acosl_compat.c b/sysdeps/ieee754/ldbl-opt/w_acosl_compat.c
index 8b6e890..5efc990 100644
--- a/sysdeps/ieee754/ldbl-opt/w_acosl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_acosl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_acosl.c>
+#include <math/w_acosl_compat.c>
 long_double_symbol (libm, __acosl, acosl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_asin_compat.c b/sysdeps/ieee754/ldbl-opt/w_asin_compat.c
index 5e1d70f..1c52cc2 100644
--- a/sysdeps/ieee754/ldbl-opt/w_asin_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_asin_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_asin.c>
+#include <math/w_asin_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __asin, asinl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_asinl_compat.c b/sysdeps/ieee754/ldbl-opt/w_asinl_compat.c
index a58a224..087fab2 100644
--- a/sysdeps/ieee754/ldbl-opt/w_asinl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_asinl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_asinl.c>
+#include <math/w_asinl_compat.c>
 long_double_symbol (libm, __asinl, asinl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_atan2_compat.c b/sysdeps/ieee754/ldbl-opt/w_atan2_compat.c
index f1d1501..d3f7964 100644
--- a/sysdeps/ieee754/ldbl-opt/w_atan2_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_atan2_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_atan2.c>
+#include <math/w_atan2_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __atan2, atan2l, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_atan2l_compat.c b/sysdeps/ieee754/ldbl-opt/w_atan2l_compat.c
index 01431ef..6b12209 100644
--- a/sysdeps/ieee754/ldbl-opt/w_atan2l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_atan2l_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_atan2l.c>
+#include <math/w_atan2l_compat.c>
 long_double_symbol (libm, __atan2l, atan2l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_atanh_compat.c b/sysdeps/ieee754/ldbl-opt/w_atanh_compat.c
index b4cab87..e15ef1f 100644
--- a/sysdeps/ieee754/ldbl-opt/w_atanh_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_atanh_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_atanh.c>
+#include <math/w_atanh_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __atanh, atanhl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_atanhl_compat.c b/sysdeps/ieee754/ldbl-opt/w_atanhl_compat.c
index 0dbc114..49bae1e 100644
--- a/sysdeps/ieee754/ldbl-opt/w_atanhl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_atanhl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_atanhl.c>
+#include <math/w_atanhl_compat.c>
 long_double_symbol (libm, __atanhl, atanhl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_cosh_compat.c b/sysdeps/ieee754/ldbl-opt/w_cosh_compat.c
index a6f56cf..af29735 100644
--- a/sysdeps/ieee754/ldbl-opt/w_cosh_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_cosh_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_cosh.c>
+#include <math/w_cosh_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __cosh, coshl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_coshl_compat.c b/sysdeps/ieee754/ldbl-opt/w_coshl_compat.c
index 8c7dccb..a880877 100644
--- a/sysdeps/ieee754/ldbl-opt/w_coshl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_coshl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_coshl.c>
+#include <math/w_coshl_compat.c>
 long_double_symbol (libm, __coshl, coshl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_exp10_compat.c b/sysdeps/ieee754/ldbl-opt/w_exp10_compat.c
index 990c48e..142a70b 100644
--- a/sysdeps/ieee754/ldbl-opt/w_exp10_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_exp10_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_exp10.c>
+#include <math/w_exp10_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_1)
 compat_symbol (libm, __exp10, exp10l, GLIBC_2_1);
 compat_symbol (libm, __pow10, pow10l, GLIBC_2_1);
diff --git a/sysdeps/ieee754/ldbl-opt/w_exp10l_compat.c b/sysdeps/ieee754/ldbl-opt/w_exp10l_compat.c
index e06dfb5..8f2ccd3 100644
--- a/sysdeps/ieee754/ldbl-opt/w_exp10l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_exp10l_compat.c
@@ -1,6 +1,6 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_exp10l.c>
+#include <math/w_exp10l_compat.c>
 long_double_symbol (libm, __exp10l, exp10l);
 long_double_symbol (libm, __pow10l, pow10l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_fmod_compat.c b/sysdeps/ieee754/ldbl-opt/w_fmod_compat.c
index 81ad505..9280d39 100644
--- a/sysdeps/ieee754/ldbl-opt/w_fmod_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_fmod_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_fmod.c>
+#include <math/w_fmod_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __fmod, fmodl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_fmodl_compat.c b/sysdeps/ieee754/ldbl-opt/w_fmodl_compat.c
index 2a534a3..88fe0ac 100644
--- a/sysdeps/ieee754/ldbl-opt/w_fmodl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_fmodl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_fmodl.c>
+#include <math/w_fmodl_compat.c>
 long_double_symbol (libm, __fmodl, fmodl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_hypot_compat.c b/sysdeps/ieee754/ldbl-opt/w_hypot_compat.c
index e1cf1ff..b3979ff 100644
--- a/sysdeps/ieee754/ldbl-opt/w_hypot_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_hypot_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_hypot.c>
+#include <math/w_hypot_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __hypot, hypotl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_hypotl_compat.c b/sysdeps/ieee754/ldbl-opt/w_hypotl_compat.c
index 6c46bd4..68e3997 100644
--- a/sysdeps/ieee754/ldbl-opt/w_hypotl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_hypotl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_hypotl.c>
+#include <math/w_hypotl_compat.c>
 long_double_symbol (libm, __hypotl, hypotl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_j0_compat.c b/sysdeps/ieee754/ldbl-opt/w_j0_compat.c
index 5c78aff..45b4d14 100644
--- a/sysdeps/ieee754/ldbl-opt/w_j0_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_j0_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_j0.c>
+#include <math/w_j0_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, j0, j0l, GLIBC_2_0);
 compat_symbol (libm, y0, y0l, GLIBC_2_0);
diff --git a/sysdeps/ieee754/ldbl-opt/w_j0l_compat.c b/sysdeps/ieee754/ldbl-opt/w_j0l_compat.c
index 767a1bc..9050657 100644
--- a/sysdeps/ieee754/ldbl-opt/w_j0l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_j0l_compat.c
@@ -1,6 +1,6 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_j0l.c>
+#include <math/w_j0l_compat.c>
 long_double_symbol (libm, __j0l, j0l);
 long_double_symbol (libm, __y0l, y0l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_j1_compat.c b/sysdeps/ieee754/ldbl-opt/w_j1_compat.c
index ed3dbc0..1071c8f 100644
--- a/sysdeps/ieee754/ldbl-opt/w_j1_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_j1_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_j1.c>
+#include <math/w_j1_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, j1, j1l, GLIBC_2_0);
 compat_symbol (libm, y1, y1l, GLIBC_2_0);
diff --git a/sysdeps/ieee754/ldbl-opt/w_j1l_compat.c b/sysdeps/ieee754/ldbl-opt/w_j1l_compat.c
index 946c364..4ed9e2d 100644
--- a/sysdeps/ieee754/ldbl-opt/w_j1l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_j1l_compat.c
@@ -1,6 +1,6 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_j1l.c>
+#include <math/w_j1l_compat.c>
 long_double_symbol (libm, __j1l, j1l);
 long_double_symbol (libm, __y1l, y1l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_jn_compat.c b/sysdeps/ieee754/ldbl-opt/w_jn_compat.c
index 7a7e0d4..be29a36 100644
--- a/sysdeps/ieee754/ldbl-opt/w_jn_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_jn_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_jn.c>
+#include <math/w_jn_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, jn, jnl, GLIBC_2_0);
 compat_symbol (libm, yn, ynl, GLIBC_2_0);
diff --git a/sysdeps/ieee754/ldbl-opt/w_jnl_compat.c b/sysdeps/ieee754/ldbl-opt/w_jnl_compat.c
index 5219543..d22ee54 100644
--- a/sysdeps/ieee754/ldbl-opt/w_jnl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_jnl_compat.c
@@ -1,6 +1,6 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_jnl.c>
+#include <math/w_jnl_compat.c>
 long_double_symbol (libm, __jnl, jnl);
 long_double_symbol (libm, __ynl, ynl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_log10_compat.c b/sysdeps/ieee754/ldbl-opt/w_log10_compat.c
index 74e7168..5ec6a2b 100644
--- a/sysdeps/ieee754/ldbl-opt/w_log10_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_log10_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_log10.c>
+#include <math/w_log10_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __log10, log10l, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_log10l_compat.c b/sysdeps/ieee754/ldbl-opt/w_log10l_compat.c
index 9c936e3..17de3e7 100644
--- a/sysdeps/ieee754/ldbl-opt/w_log10l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_log10l_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_log10l.c>
+#include <math/w_log10l_compat.c>
 long_double_symbol (libm, __log10l, log10l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_log2_compat.c b/sysdeps/ieee754/ldbl-opt/w_log2_compat.c
index 9b9b45b..dffd2c1 100644
--- a/sysdeps/ieee754/ldbl-opt/w_log2_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_log2_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_log2.c>
+#include <math/w_log2_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_1)
 compat_symbol (libm, __log2, log2l, GLIBC_2_1);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_log2l_compat.c b/sysdeps/ieee754/ldbl-opt/w_log2l_compat.c
index c859682..3c5e734 100644
--- a/sysdeps/ieee754/ldbl-opt/w_log2l_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_log2l_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_log2l.c>
+#include <math/w_log2l_compat.c>
 long_double_symbol (libm, __log2l, log2l);
diff --git a/sysdeps/ieee754/ldbl-opt/w_log_compat.c b/sysdeps/ieee754/ldbl-opt/w_log_compat.c
index bde1e31..d2a2bca 100644
--- a/sysdeps/ieee754/ldbl-opt/w_log_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_log_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_log.c>
+#include <math/w_log_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __log, logl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_logl_compat.c b/sysdeps/ieee754/ldbl-opt/w_logl_compat.c
index c2354a0..2b55842 100644
--- a/sysdeps/ieee754/ldbl-opt/w_logl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_logl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_logl.c>
+#include <math/w_logl_compat.c>
 long_double_symbol (libm, __logl, logl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_pow_compat.c b/sysdeps/ieee754/ldbl-opt/w_pow_compat.c
index 2d98fb9..c2a7942 100644
--- a/sysdeps/ieee754/ldbl-opt/w_pow_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_pow_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_pow.c>
+#include <math/w_pow_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __pow, powl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_powl_compat.c b/sysdeps/ieee754/ldbl-opt/w_powl_compat.c
index 85b8927..1897cf1 100644
--- a/sysdeps/ieee754/ldbl-opt/w_powl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_powl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_powl.c>
+#include <math/w_powl_compat.c>
 long_double_symbol (libm, __powl, powl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_remainder_compat.c b/sysdeps/ieee754/ldbl-opt/w_remainder_compat.c
index dfa7b7f..c823dcb 100644
--- a/sysdeps/ieee754/ldbl-opt/w_remainder_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_remainder_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_remainder.c>
+#include <math/w_remainder_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __remainder, remainderl, GLIBC_2_0);
 strong_alias (__remainder, __drem)
diff --git a/sysdeps/ieee754/ldbl-opt/w_remainderl_compat.c b/sysdeps/ieee754/ldbl-opt/w_remainderl_compat.c
index 7a344b7..b2ce5c9 100644
--- a/sysdeps/ieee754/ldbl-opt/w_remainderl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_remainderl_compat.c
@@ -1,7 +1,7 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_remainderl.c>
+#include <math/w_remainderl_compat.c>
 long_double_symbol (libm, __remainderl, remainderl);
 strong_alias (__remainderl, __dreml)
 long_double_symbol (libm, __dreml, dreml);
diff --git a/sysdeps/ieee754/ldbl-opt/w_scalb_compat.c b/sysdeps/ieee754/ldbl-opt/w_scalb_compat.c
index e2ac601..f6d53a5 100644
--- a/sysdeps/ieee754/ldbl-opt/w_scalb_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_scalb_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_scalb.c>
+#include <math/w_scalb_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __scalb, scalbl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_scalbl_compat.c b/sysdeps/ieee754/ldbl-opt/w_scalbl_compat.c
index f3d3901..c8feb65 100644
--- a/sysdeps/ieee754/ldbl-opt/w_scalbl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_scalbl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_scalbl.c>
+#include <math/w_scalbl_compat.c>
 long_double_symbol (libm, __scalbl, scalbl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_sinh_compat.c b/sysdeps/ieee754/ldbl-opt/w_sinh_compat.c
index a5400b5..b47182c 100644
--- a/sysdeps/ieee754/ldbl-opt/w_sinh_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_sinh_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_sinh.c>
+#include <math/w_sinh_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __sinh, sinhl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_sinhl_compat.c b/sysdeps/ieee754/ldbl-opt/w_sinhl_compat.c
index b94f4ec..305ed82 100644
--- a/sysdeps/ieee754/ldbl-opt/w_sinhl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_sinhl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_sinhl.c>
+#include <math/w_sinhl_compat.c>
 long_double_symbol (libm, __sinhl, sinhl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_sqrt_compat.c b/sysdeps/ieee754/ldbl-opt/w_sqrt_compat.c
index ca2ba06..355d1c2 100644
--- a/sysdeps/ieee754/ldbl-opt/w_sqrt_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_sqrt_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_sqrt.c>
+#include <math/w_sqrt_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_0)
 compat_symbol (libm, __sqrt, sqrtl, GLIBC_2_0);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_sqrtl_compat.c b/sysdeps/ieee754/ldbl-opt/w_sqrtl_compat.c
index 609f5bf..1e4526f 100644
--- a/sysdeps/ieee754/ldbl-opt/w_sqrtl_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_sqrtl_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_sqrtl.c>
+#include <math/w_sqrtl_compat.c>
 long_double_symbol (libm, __sqrtl, sqrtl);
diff --git a/sysdeps/ieee754/ldbl-opt/w_tgamma_compat.c b/sysdeps/ieee754/ldbl-opt/w_tgamma_compat.c
index cce9f34..082ce8a 100644
--- a/sysdeps/ieee754/ldbl-opt/w_tgamma_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_tgamma_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
-#include <math/w_tgamma.c>
+#include <math/w_tgamma_compat.c>
 #if LONG_DOUBLE_COMPAT(libm, GLIBC_2_1)
 compat_symbol (libm, __tgamma, tgammal, GLIBC_2_1);
 #endif
diff --git a/sysdeps/ieee754/ldbl-opt/w_tgammal_compat.c b/sysdeps/ieee754/ldbl-opt/w_tgammal_compat.c
index c3c511d..aaf5403 100644
--- a/sysdeps/ieee754/ldbl-opt/w_tgammal_compat.c
+++ b/sysdeps/ieee754/ldbl-opt/w_tgammal_compat.c
@@ -1,5 +1,5 @@
 #include <math_ldbl_opt.h>
 #undef weak_alias
 #define weak_alias(n,a)
-#include <math/w_tgammal.c>
+#include <math/w_tgammal_compat.c>
 long_double_symbol (libm, __tgammal, tgammal);